## libwebcam 0.2.0

=== libwebcam/CMakeLists.txt ===
#
# GENERAL
#

# Require CMake 2.6 because of the Debian packaging.
cmake_minimum_required (VERSION 2.6)

project (LIBWEBCAM)


#
# TARGETS
#

add_library (webcam SHARED libwebcam.c dynctrl.c)
add_library (webcam_static STATIC libwebcam.c dynctrl.c)

set_target_properties (webcam PROPERTIES VERSION 0.2.0 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
set_target_properties (webcam_static PROPERTIES VERSION 0.2.0 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")


#
# COMPILATION AND LINKING
#

# Require LibXML
#include (FindLibXml2)
include (FindPkgConfig)
pkg_check_modules (LIBXML2 REQUIRED libxml-2.0)

# Require uvcvideo
find_path (UVCVIDEO_INCLUDE_DIR uvcvideo.h)
if (NOT UVCVIDEO_INCLUDE_DIR)
	message(FATAL_ERROR "Linux UVC Driver sources (uvcvideo.h) not found. Try adding its path to the CMAKE_INCLUDE_PATH environment variable.")
endif (NOT UVCVIDEO_INCLUDE_DIR)
message("** Found Linux UVC Driver sources: ${UVCVIDEO_INCLUDE_DIR}")

# Check V4L2
try_compile (HAS_V4L2_STRING_CONTROLS ${CMAKE_BINARY_DIR}/ ${CMAKE_CURRENT_SOURCE_DIR}/../common/build/cmake_try_v4l2_ctrl_type_string.c)
if (HAS_V4L2_STRING_CONTROLS)
	message("** Your V4L2 has V4L2_CTRL_TYPE_STRING support. Enabling raw control support.")
	add_definitions (-DENABLE_RAW_CONTROLS)
else (HAS_V4L2_STRING_CONTROLS)
	message("** Your V4L2 does not have V4L2_CTRL_TYPE_STRING support. Compiling without raw control support.")
endif (HAS_V4L2_STRING_CONTROLS)

# Includes
include_directories (include ${LIBXML2_INCLUDE_DIRS} ${UVCVIDEO_INCLUDE_DIR} ../common/include)

# Libraries
target_link_libraries (webcam ${LIBXML2_LIBRARIES})
target_link_libraries (webcam_static ${LIBXML2_LIBRARIES})

# Compiler flags
set_target_properties (webcam PROPERTIES
	COMPILE_FLAGS "-Wall"
)
set_target_properties (webcam_static PROPERTIES
	COMPILE_FLAGS "-Wall"
)
# create libwebcam.pc (for pkg-config)
execute_process (
	COMMAND			sh -c "sed -e 's_<--PREFIX--!>_${CMAKE_INSTALL_PREFIX}_g' ${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/libwebcam.pc_base  > ${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/libwebcam.pc"
	RESULT_VARIABLE		PC_EXECUTE_RESULT
	ERROR_QUIET
)

if (PC_EXECUTE_RESULT)
	message(ERROR " Unable to parse ${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/libwebcam.pc_base")
else (PC_EXECUTE_RESULT)
	message("** created libwecam.pc")
endif (PC_EXECUTE_RESULT)

#
# INSTALLATION
#

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	SET(CMAKE_INSTALL_LIBDIR "lib")
endif (NOT DEFINED CMAKE_INSTALL_LIBDIR)

if (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
	message("** Installation directory for libwebcam: ${CMAKE_INSTALL_LIBDIR}")
else (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
	message("** Installation directory for libwebcam: ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")

install (
	TARGETS					webcam webcam_static
	LIBRARY DESTINATION		${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION		${CMAKE_INSTALL_LIBDIR}
	COMPONENT				LIBWEBCAM
)

# udev rules, script, and data
# Default permissions for DIRECTORY files: rw-r--r--
# Default permissions for PROGRAMS files:  rwxr-xr-x
# Note that having absolute paths here requires CPACK_SET_DESTDIR to be set to "ON".
install (
	FILES	pkgconfig/libwebcam.pc
	DESTINATION 	${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install (
	FILES	../common/include/webcam.h
	DESTINATION 	${CMAKE_INSTALL_PREFIX}/include
)



# Source packaging
# use shell script instead

=== uvcdynctrl/CMakeLists.txt ===
#
# GENERAL
#

# Require CMake 2.6 because of the Debian packaging.
cmake_minimum_required (VERSION 2.6)

project (UVCDYNCTRL)



#
# TARGETS
#

add_executable (uvcdynctrl main.c controls.c cmdline.c)

set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.0)


if (NOT DYNCTRL_DATA_DIR)
	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/uvcdynctrl")
else (NOT DYNCTRL_DATA_DIR)
	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR ${DYNCTRL_DATA_DIR})
endif (NOT DYNCTRL_DATA_DIR)

#
# SPECIAL FILES
#

# gengetopt for command line parsing
if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.c" AND NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.h")
	message("** Command line parser source files not found. Creating gengetopt rules ...")

	# Check if gengetopt is installed
	find_program(GENGETOPT gengetopt)
	if (NOT GENGETOPT)
		message(FATAL_ERROR "Unable to find gengetopt")
	endif (NOT GENGETOPT)

	add_custom_command (
		OUTPUT		${CMAKE_CURRENT_SOURCE_DIR}/cmdline.c ${CMAKE_CURRENT_SOURCE_DIR}/cmdline.h
		COMMAND		gengetopt -i ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.ggo --output-dir ${CMAKE_CURRENT_SOURCE_DIR} --unamed-opts=VALUES
		DEPENDS 	${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.ggo
		COMMENT		"Generating getopt parser code (cmdline.*) ..."
		VERBATIM
	)
endif (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.c" AND NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.h")

# config.h
# Note how we define HAVE_CONFIG_H. This will let gengetopt pick up
# the VERSION constant from config.h.
get_target_property (UVCDYNCTRL_VERSION uvcdynctrl VERSION)
get_target_property (UVCDYNCTRL_DATA_DIR uvcdynctrl DATA_DIR)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
add_definitions (-DHAVE_CONFIG_H)

#create man pages
execute_process (
	COMMAND			sh -c "cp ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1_ ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1; cp ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1_ ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl-0.2.0.1; gzip --best ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl-0.2.0.1; gzip --best ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1;"
	RESULT_VARIABLE		MAN_BUILD_RESULT
	
)

if (MAN_BUILD_RESULT)
	message(ERROR " Unable to build man pages")
else (MAN_BUILD_RESULT)
	message("** created man pages")
endif (MAN_BUILD_RESULT)


#
# COMPILATION AND LINKING
#

include_directories (../common/include)
include_directories (${CMAKE_CURRENT_BINARY_DIR})
link_directories (${LIBWEBCAM_BINARY_DIR}/webcam)

target_link_libraries (uvcdynctrl webcam)

# Compiler flags
set_target_properties (uvcdynctrl PROPERTIES
	COMPILE_FLAGS "--std=gnu99 -Wall"
)

#
# INSTALLATION
#

# uvcdynctrl binary
message("** Installation directory for uvcdynctrl: ${CMAKE_INSTALL_PREFIX}/bin")
install (
	TARGETS					uvcdynctrl
	RUNTIME DESTINATION		bin
	COMPONENT				UVCDYNCTRL
)

# udev rules, script, and data
# Default permissions for DIRECTORY files: rw-r--r--
# Default permissions for PROGRAMS files:  rwxr-xr-x
# Note that having absolute paths here requires CPACK_SET_DESTDIR to be set to "ON".
install (
	FILES	udev/rules/85-uvcdynctrl.rules
	DESTINATION /lib/udev/rules.d
)
install (
	PROGRAMS	udev/scripts/uvcdynctrl
	DESTINATION	/lib/udev
)
install (
	DIRECTORY	data
	DESTINATION ${UVCDYNCTRL_DATA_DIR}
	PATTERN ".svn" EXCLUDE
)
install (
	FILES	uvcdynctrl.1.gz uvcdynctrl-0.2.0.1.gz 
	DESTINATION share/man/man1
)

















#
# Packaging
#

# Prerequisites
execute_process (
	COMMAND				/usr/bin/dpkg --print-architecture
	OUTPUT_VARIABLE		CPACK_DEBIAN_PACKAGE_ARCHITECTURE
	RESULT_VARIABLE		EXECUTE_RESULT
	OUTPUT_STRIP_TRAILING_WHITESPACE
	ERROR_QUIET
)
if (EXECUTE_RESULT)
	message(FATAL_ERROR "Unable to determine current dpkg architecture: ${EXECUTE_RESULT}")
else (EXECUTE_RESULT)
	message("** Debian package architecture: ${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
endif (EXECUTE_RESULT)

# Generic
set (CPACK_GENERATOR					"TBZ2;DEB")
set (CPACK_PACKAGE_NAME					"uvcdynctrl")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY	"Manage dynamic controls in uvcvideo")
set (CPACK_PACKAGE_DESCRIPTION			"Command line tool to obtain and change camera controls and manage dynamic controls.")
set (CPACK_RESOURCE_FILE_LICENSE		"${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set (CPACK_RESOURCE_FILE_README			"${CMAKE_CURRENT_SOURCE_DIR}/README")
set (CPACK_PACKAGE_VENDOR				"Logitech")
set (CPACK_PACKAGE_VERSION				"${UVCDYNCTRL_VERSION}")
set (CPACK_PACKAGE_FILE_NAME			"${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
set (CPACK_SET_DESTDIR					"ON")	# Necessary because of the absolute install paths

# Debian
# The dependencies are obtained by extracting the (dependency lacking) .deb package
# into a directory called 'debian', adding a fake "Source: ..." line to the debian/control
# file and running 'dpkg-shlibdeps -O debian/usr/bin/uvcdynctrl'.
set (CPACK_DEBIAN_PACKAGE_MAINTAINER	"Martin Rubli <martin_rubli@logitech.com>")
set (CPACK_DEBIAN_PACKAGE_DEPENDS		"libwebcam (>= 0.2), libc6 (>= 2.7)")

# Instead of actually packing we just generate a CPack configuration file. The top level
# README file explains how to package the project.
if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../common/build/CPackConfig.cmake.conf")
	message ("** Creating CPack configuration file for ${CPACK_PACKAGE_NAME} ...")
	configure_file (
		${CMAKE_CURRENT_SOURCE_DIR}/../common/build/CPackConfig.cmake.conf
		${CMAKE_CURRENT_BINARY_DIR}/CPackConfig.cmake
	)
endif (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../common/build/CPackConfig.cmake.conf")

# Source packaging
# Note that we only enable source packaging if we're not building from the top-level
# directory. The reason for this is that source packaging at the top-level includes
# the entire tree by default and exclude patterns are not suitable in our case.
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
	set (CPACK_SOURCE_GENERATOR				"TBZ2")
	set (CPACK_SOURCE_PACKAGE_FILE_NAME		"${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")

	# The following is a list of semicolon separate regexp patterns of files and
	# directories to ignore. Regexp anchors like ^ and $ can be used but because
	# CPack matches entire paths ^ won't work for file matching. We can use / on
	# the left-hand side instead. Also note that backslashes need to be double-
	# escaped (i.e. \\\\). Therefore Perl's \. to match a dot becomes \\\\. here.
	set (CPACK_SOURCE_IGNORE_FILES
		"/\\\\.svn/"								# Subversion directories
		"/\\\\..+$"									# Hidden files and directories
		"build"										# Build directories
		"tags;/doxygen-output"						# Misc
	)

	include (CPack)
endif (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})

## libwebcam 0.2.1

=== CMakeLists.txt ===
#
# GENERAL
#

# Require CMake 2.6 because of the Debian packaging.
cmake_minimum_required (VERSION 2.6)



#
# SUBDIRECTORIES
#

add_subdirectory (libwebcam)
add_subdirectory (uvcdynctrl)

=== libwebcam/CMakeLists.txt ===
#
# GENERAL
#

# Require CMake 2.6 because of the Debian packaging.
cmake_minimum_required (VERSION 2.6)

project (LIBWEBCAM)



#
# TARGETS
#

add_library (webcam SHARED libwebcam.c dynctrl.c)

set_target_properties (webcam PROPERTIES VERSION 0.2.1)



#
# COMPILATION AND LINKING
#

# Require LibXML
#include (FindLibXml2)
include (FindPkgConfig)
pkg_check_modules (LIBXML2 REQUIRED libxml-2.0)

# Require uvcvideo
message ("** Checking for uvcvideo ...")
unset (UVCVIDEO_INCLUDE_DIR CACHE)
unset (UVCVIDEO_INCLUDE_DIR)
if (UVCVIDEO_INCLUDE_PATH)
	message ("**   Overriding uvcvideo.h search path: ${UVCVIDEO_INCLUDE_PATH}")
	find_path (UVCVIDEO_INCLUDE_DIR
		#uvcvideo.h
		NAMES linux/uvcvideo.h uvcvideo.h
		PATHS ${UVCVIDEO_INCLUDE_PATH}
		#PATH_SUFFIXES linux
		NO_DEFAULT_PATH		# If the user is explicit don't look in standard paths
	)
else (UVCVIDEO_INCLUDE_PATH)
	find_path (UVCVIDEO_INCLUDE_DIR
		#uvcvideo.h
		NAMES linux/uvcvideo.h uvcvideo.h
		PATHS ${UVCVIDEO_INCLUDE_PATH}
		#PATH_SUFFIXES linux
	)
endif (UVCVIDEO_INCLUDE_PATH)
if (NOT UVCVIDEO_INCLUDE_DIR)
	message(FATAL_ERROR "Linux UVC Driver include file (linux/uvcvideo.h or uvcvideo.h) not found. Try adding -DUVCVIDEO_INCLUDE_PATH=... to specify its path.")
else (NOT UVCVIDEO_INCLUDE_DIR)
	message("**   Found Linux UVC Driver include file in: ${UVCVIDEO_INCLUDE_DIR}")
	find_file (PUBLIC_UVCVIDEO_H_PATH "linux/uvcvideo.h" PATHS ${UVCVIDEO_INCLUDE_DIR} NO_DEFAULT_PATH)
	if (NOT PUBLIC_UVCVIDEO_H_PATH)
		message("**   Using old-style uvcvideo.h from uvcvideo sources instead of public linux/uvcvideo.h.")
		set (EXTRA_COMPILE_FLAGS "-DUSE_PRIVATE_UVCVIDEO_H")
	endif (NOT PUBLIC_UVCVIDEO_H_PATH)
endif (NOT UVCVIDEO_INCLUDE_DIR)

# Require V4L2
message ("** Checking for V4L2 ...")
unset (V4L2_INCLUDE_DIR CACHE)
unset (V4L2_INCLUDE_DIR)
if (V4L2_INCLUDE_PATH)
	message ("**   Overriding videodev2.h search path: ${V4L2_INCLUDE_PATH}")
	find_path (V4L2_INCLUDE_DIR
		linux/videodev2.h
		PATHS ${V4L2_INCLUDE_PATH}
		NO_DEFAULT_PATH		# If the user is explicit don't look in standard paths
	)
else (V4L2_INCLUDE_PATH)
	find_path (V4L2_INCLUDE_DIR
		linux/videodev2.h
		PATHS ${V4L2_INCLUDE_PATH}
	)
endif (V4L2_INCLUDE_PATH)
if (NOT V4L2_INCLUDE_DIR)
	message(FATAL_ERROR "V4L2 include file (linux/videodev2.h) not found. Try adding -DV4L2_INCLUDE_PATH=... to specify its path.")
else (NOT V4L2_INCLUDE_DIR)
	message("**   Found V4L2 include file in: ${V4L2_INCLUDE_DIR}")
endif (NOT V4L2_INCLUDE_DIR)

# Feature check: V4L2 with V4L2_STRING_CONTROLS support
try_compile (HAS_V4L2_STRING_CONTROLS
	${CMAKE_BINARY_DIR}/
	${CMAKE_CURRENT_SOURCE_DIR}/../common/build/cmake_try_v4l2_ctrl_type_string.c
	CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${V4L2_INCLUDE_DIR}"
)
if (HAS_V4L2_STRING_CONTROLS)
	message("**   Your V4L2 has V4L2_CTRL_TYPE_STRING support. Enabling raw control support.")
	add_definitions (-DENABLE_RAW_CONTROLS)
else (HAS_V4L2_STRING_CONTROLS)
	message("**   Your V4L2 does NOT have V4L2_CTRL_TYPE_STRING support. Compiling WITHOUT raw control support.")
endif (HAS_V4L2_STRING_CONTROLS)

# Includes
include_directories (include ../common/include ${LIBXML2_INCLUDE_DIRS} ${UVCVIDEO_INCLUDE_DIR} ${V4L2_INCLUDE_DIR})

# Libraries
target_link_libraries (webcam ${LIBXML2_LIBRARIES})

# Compiler flags
set_target_properties (webcam PROPERTIES
	COMPILE_FLAGS "-Wall ${EXTRA_COMPILE_FLAGS}"
)



#
# INSTALLATION
#

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	SET(CMAKE_INSTALL_LIBDIR "lib")
endif (NOT DEFINED CMAKE_INSTALL_LIBDIR)

if (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
	message("** Installation directory for libwebcam: ${CMAKE_INSTALL_LIBDIR}")
else (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
	message("** Installation directory for libwebcam: ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
install (
	TARGETS					webcam
	LIBRARY DESTINATION		${CMAKE_INSTALL_LIBDIR}
	COMPONENT				LIBWEBCAM
)



#
# PACKAGING
#

# Prerequisites
execute_process (
	COMMAND				/usr/bin/dpkg --print-architecture
	OUTPUT_VARIABLE		CPACK_DEBIAN_PACKAGE_ARCHITECTURE
	RESULT_VARIABLE		EXECUTE_RESULT
	OUTPUT_STRIP_TRAILING_WHITESPACE
	ERROR_QUIET
)
if (EXECUTE_RESULT)
	message(FATAL_ERROR "Unable to determine current dpkg architecture: ${EXECUTE_RESULT}")
else (EXECUTE_RESULT)
	message("** Debian package architecture: ${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")
endif (EXECUTE_RESULT)

# Generic
set (CPACK_GENERATOR					"TBZ2;DEB")
set (CPACK_PACKAGE_NAME					"libwebcam")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY	"Webcam utility library")
set (CPACK_PACKAGE_DESCRIPTION			"Provides camera, control, and frame format enumeration and simplifies camera control access. Also allows for configuring the Linux UVC driver's dynamic control mechanism.")
set (CPACK_RESOURCE_FILE_LICENSE		"${CMAKE_CURRENT_SOURCE_DIR}/COPYING.LESSER")
set (CPACK_RESOURCE_FILE_README			"${CMAKE_CURRENT_SOURCE_DIR}/README")
set (CPACK_PACKAGE_VENDOR				"Logitech")
set (CPACK_PACKAGE_VERSION				"0.2.1")
set (CPACK_PACKAGE_FILE_NAME			"${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}-${CPACK_DEBIAN_PACKAGE_ARCHITECTURE}")

# Debian
# The dependencies are obtained by extracting the (dependency lacking) .deb package
# into a directory called 'debian', adding a fake "Source: ..." line to the debian/control
# file and running 'dpkg-shlibdeps -O debian/usr/lib/libwebcam.so'.
set (CPACK_DEBIAN_PACKAGE_MAINTAINER	"Martin Rubli <martin_rubli@logitech.com>")
set (CPACK_DEBIAN_PACKAGE_DEPENDS		"libxml2 (>= 2.6.27), libc6 (>= 2.4)")

# Instead of actually packing we just generate a CPack configuration file. The top level
# README file explains how to package the project.
if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../common/build/CPackConfig.cmake.conf")
	message ("** Creating CPack configuration file for ${CPACK_PACKAGE_NAME} ...")
	configure_file (
		${CMAKE_CURRENT_SOURCE_DIR}/../common/build/CPackConfig.cmake.conf
		${CMAKE_CURRENT_BINARY_DIR}/CPackConfig.cmake
	)
endif (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../common/build/CPackConfig.cmake.conf")

# Source packaging
# Note that we only enable source packaging if we're not building from the top-level
# directory. The reason for this is that source packaging at the top-level includes
# the entire tree by default and exclude patterns are not suitable in our case.
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
	set (CPACK_SOURCE_GENERATOR				"TBZ2")
	set (CPACK_SOURCE_PACKAGE_FILE_NAME		"${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")

	# The following is a list of semicolon separate regexp patterns of files and
	# directories to ignore. Regexp anchors like ^ and $ can be used but because
	# CPack matches entire paths ^ won't work for file matching. We can use / on
	# the left-hand side instead. Also note that backslashes need to be double-
	# escaped (i.e. \\\\). Therefore Perl's \. to match a dot becomes \\\\. here.
	set (CPACK_SOURCE_IGNORE_FILES
		"/\\\\.svn/"								# Subversion directories
		"/\\\\..+$"									# Hidden files and directories
		"build"										# Build directories
		"tags;/doxygen-output"						# Misc
	)

	include (CPack)
endif (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})

=== uvcdynctrl/CMakeLists.txt ===
--- 
+++ 
@@ -15,14 +15,9 @@
 
 add_executable (uvcdynctrl main.c controls.c cmdline.c)
 
-set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.0)
+set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.1)
 
 
-if (NOT DYNCTRL_DATA_DIR)
-	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/uvcdynctrl")
-else (NOT DYNCTRL_DATA_DIR)
-	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR ${DYNCTRL_DATA_DIR})
-endif (NOT DYNCTRL_DATA_DIR)
 
 #
 # SPECIAL FILES
@@ -51,22 +46,9 @@
 # Note how we define HAVE_CONFIG_H. This will let gengetopt pick up
 # the VERSION constant from config.h.
 get_target_property (UVCDYNCTRL_VERSION uvcdynctrl VERSION)
-get_target_property (UVCDYNCTRL_DATA_DIR uvcdynctrl DATA_DIR)
 configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 add_definitions (-DHAVE_CONFIG_H)
 
-#create man pages
-execute_process (
-	COMMAND			sh -c "cp ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1_ ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1; cp ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1_ ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl-0.2.0.1; gzip --best ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl-0.2.0.1; gzip --best ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1;"
-	RESULT_VARIABLE		MAN_BUILD_RESULT
-	
-)
-
-if (MAN_BUILD_RESULT)
-	message(ERROR " Unable to build man pages")
-else (MAN_BUILD_RESULT)
-	message("** created man pages")
-endif (MAN_BUILD_RESULT)
 
 
 #
@@ -101,8 +83,9 @@
 # Default permissions for PROGRAMS files:  rwxr-xr-x
 # Note that having absolute paths here requires CPACK_SET_DESTDIR to be set to "ON".
 install (
-	FILES	udev/rules/85-uvcdynctrl.rules
-	DESTINATION /lib/udev/rules.d
+	DIRECTORY	udev/rules/
+	DESTINATION /etc/udev/rules.d
+	PATTERN ".svn" EXCLUDE
 )
 install (
 	PROGRAMS	udev/scripts/uvcdynctrl
@@ -110,27 +93,9 @@
 )
 install (
 	DIRECTORY	data
-	DESTINATION ${UVCDYNCTRL_DATA_DIR}
+	DESTINATION /etc/udev
 	PATTERN ".svn" EXCLUDE
 )
-install (
-	FILES	uvcdynctrl.1.gz uvcdynctrl-0.2.0.1.gz 
-	DESTINATION share/man/man1
-)
-
-
-
-
-
-
-
-
-
-
-
-
-
-

=== debian/changelog ===
libwebcam (0.2.1-1build1) precise; urgency=low

  * No-change rebuild against current pkgbinarymangler to fix broken
    md5sums. (see LP #875466)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 29 Feb 2012 08:42:50 +0100

libwebcam (0.2.1-1) unstable; urgency=low

  [ Paulo Assis ]
  * Update to 0.2.1 (Closes: #621972)
  * Switch to dpkg-source 3.0 (quilt) format
  * Update Debian Standards Version to 3.9.2
  * Move some code not accepted in trunk to debian patches:
    - CMakeLists.patch
    - man_page.patch
    - pkgconfig.patch
    - load_store_controls.patch
    - add_controls.patch
  * Transition debian patches to DEP3 format:
    - http://dep.debian.net/deps/dep3
  * Transition debian/copyright to DEP5 format:
    - http://dep.debian.net/deps/dep5

 -- Paulo Assis <pj.assis@gmail.com>  Fri, 20 May 2011 21:47:20 +0100

libwebcam (0.2.0-1) unstable; urgency=low

  * Initial release (Closes: #568732)

 -- Paulo Assis <pj.assis@gmail.com>  Wed, 07 Feb 2010 12:57:00 +0000

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# shared library version
version= 0.2.1
deb_version=$(shell dpkg-parsechangelog | sed -n 's/^Version: //p')

major=0

builddir/Makefile:
	dh_quilt_patch 
	dh_testdir
	# Add here commands to configure the package.
	mkdir -p builddir
	cd builddir && cmake .. -DCMAKE_INCLUDE_PATH=../common/include \
		-DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_C_FLAGS="$(CFLAGS)" \
		-DCMAKE_LD_FLAGS="-Wl,-z,defs" -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
		-DCMAKE_SKIP_RPATH=ON -DCMAKE_VERBOSE_MAKEFILE=ON

#build-doxy: build-doxy-stamp
#build-doxy-stamp: $(QUILT_STAMPFN)
#	dh_testdir
#	doxygen
#	touch $@

build:  build-stamp
	
build-stamp:  builddir/Makefile 
	dh_testdir
	# Add here commands to compile the package.
	$(MAKE) -C builddir
	touch $@

clean: 
	dh_quilt_unpatch
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	# Add here commands to clean up after the build process.
	rm -rf libwebcam/pkgconfig/libwebcam.pc
	rm -rf uvcdynctrl/*.gz
	rm -rf builddir
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep  
	dh_installdirs
	# Add here commands to install the package into debian/tmp
	$(MAKE) -C builddir DESTDIR=$(CURDIR)/debian/tmp install
	dh_install --fail-missing --sourcedir=debian/tmp


# Build architecture-independent files (doc and data).
binary-indep: install
	dh_testdir -puvcdynctrl-data
	dh_testroot -puvcdynctrl-data
	dh_installchangelogs -puvcdynctrl-data
	dh_installdocs -puvcdynctrl-data debian/copyright
	dh_lintian -puvcdynctrl-data
	dh_link -puvcdynctrl-data
	dh_compress -puvcdynctrl-data
	dh_fixperms -puvcdynctrl-data
	dh_installdeb -puvcdynctrl-data
	dh_gencontrol -puvcdynctrl-data
	dh_md5sums -puvcdynctrl-data
# build deb packages 
	dh_builddeb -puvcdynctrl-data

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a debian/copyright
	dh_lintian -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_strip --exclude=uvcdynctrl --dbg-package=libwebcam0-dbg
	dh_strip --exclude=libwebcam0 --dbg-package=uvcdynctrl-dbg
# strict internal dependencies
	dh_makeshlibs -p"libwebcam0" -V"libwebcam0 (>= $(deb_version))";
	env LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(CURDIR)/debian/tmp/usr/lib" \
	dh_shlibdeps
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
# build deb packages 
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## libwebcam 0.2.2

=== libwebcam/CMakeLists.txt ===
#
# GENERAL
#

# Require CMake 2.6 because of the Debian packaging.
cmake_minimum_required (VERSION 2.6)

project (LIBWEBCAM)



#
# TARGETS
#

add_library (webcam SHARED libwebcam.c dynctrl.c)
add_library (webcam_static STATIC libwebcam.c dynctrl.c)

set_target_properties (webcam PROPERTIES VERSION 0.2.2 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
set_target_properties (webcam_static PROPERTIES VERSION 0.2.2 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")



#
# COMPILATION AND LINKING
#

# Require LibXML
#include (FindLibXml2)
include (FindPkgConfig)
pkg_check_modules (LIBXML2 REQUIRED libxml-2.0)

# Check V4L2
try_compile (HAS_V4L2_STRING_CONTROLS ${CMAKE_BINARY_DIR}/ ${CMAKE_CURRENT_SOURCE_DIR}/../common/build/cmake_try_v4l2_ctrl_type_string.c)
if (HAS_V4L2_STRING_CONTROLS)
	message("** Your V4L2 has V4L2_CTRL_TYPE_STRING support. Enabling raw control support.")
	add_definitions (-DENABLE_RAW_CONTROLS)
else (HAS_V4L2_STRING_CONTROLS)
	message("** Your V4L2 does not have V4L2_CTRL_TYPE_STRING support. Compiling without raw control support.")
endif (HAS_V4L2_STRING_CONTROLS)

# Includes
include_directories (include ${LIBXML2_INCLUDE_DIRS} ../common/include)

# Libraries
target_link_libraries (webcam ${LIBXML2_LIBRARIES})
target_link_libraries (webcam_static ${LIBXML2_LIBRARIES})

# Compiler flags
set_target_properties (webcam PROPERTIES
	COMPILE_FLAGS "-Wall"
)

set_target_properties (webcam_static PROPERTIES
	COMPILE_FLAGS "-Wall ${EXTRA_COMPILE_FLAGS}"
)

# create libwebcam.pc (for pkg-config)
execute_process (
	COMMAND			sh -c "sed -e 's_<--PREFIX--!>_${CMAKE_INSTALL_PREFIX}_g' ${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/libwebcam.pc_base  > ${CMAKE_CURRENT_BINARY_DIR}/libwebcam.pc"
	RESULT_VARIABLE		PC_EXECUTE_RESULT
	ERROR_QUIET
)
 
if (PC_EXECUTE_RESULT)
	message(ERROR " Unable to parse ${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/libwebcam.pc_base")
else (PC_EXECUTE_RESULT)
	message("** created libwecam.pc")
endif (PC_EXECUTE_RESULT)



#
# INSTALLATION
#

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	SET(CMAKE_INSTALL_LIBDIR "lib")
endif (NOT DEFINED CMAKE_INSTALL_LIBDIR)

if (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
	message("** Installation directory for libwebcam: ${CMAKE_INSTALL_LIBDIR}")
else (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
	message("** Installation directory for libwebcam: ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")
install (
	TARGETS					webcam webcam_static
	LIBRARY DESTINATION		${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION		${CMAKE_INSTALL_LIBDIR}
	COMPONENT				LIBWEBCAM
)

# Default permissions for DIRECTORY files: rw-r--r--
# Default permissions for PROGRAMS files:  rwxr-xr-x
# Note that having absolute paths here requires CPACK_SET_DESTDIR to be set to "ON".
install (
	FILES	${CMAKE_CURRENT_BINARY_DIR}/libwebcam.pc
	DESTINATION 	${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install (
	FILES	../common/include/webcam.h
	DESTINATION 	${CMAKE_INSTALL_PREFIX}/include
)

=== uvcdynctrl/CMakeLists.txt ===
#
# GENERAL
#

# Require CMake 2.6 because of the Debian packaging.
cmake_minimum_required (VERSION 2.6)

project (UVCDYNCTRL)



#
# TARGETS
#

add_executable (uvcdynctrl main.c controls.c cmdline.c)

set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.2)

if (NOT DYNCTRL_DATA_DIR)
	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/uvcdynctrl")
else (NOT DYNCTRL_DATA_DIR)
	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR ${DYNCTRL_DATA_DIR})
endif (NOT DYNCTRL_DATA_DIR)



#
# SPECIAL FILES
#

# gengetopt for command line parsing
if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.c" AND NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.h")
	message("** Command line parser source files not found. Creating gengetopt rules ...")

	# Check if gengetopt is installed
	find_program(GENGETOPT gengetopt)
	if (NOT GENGETOPT)
		message(FATAL_ERROR "Unable to find gengetopt")
	endif (NOT GENGETOPT)

	add_custom_command (
		OUTPUT		${CMAKE_CURRENT_SOURCE_DIR}/cmdline.c ${CMAKE_CURRENT_SOURCE_DIR}/cmdline.h
		COMMAND		gengetopt -i ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.ggo --output-dir ${CMAKE_CURRENT_SOURCE_DIR} --unamed-opts=VALUES
		DEPENDS 	${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.ggo
		COMMENT		"Generating getopt parser code (cmdline.*) ..."
		VERBATIM
	)
endif (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.c" AND NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmdline.h")

# config.h
# Note how we define HAVE_CONFIG_H. This will let gengetopt pick up
# the VERSION constant from config.h.
get_target_property (UVCDYNCTRL_VERSION uvcdynctrl VERSION)
get_target_property (UVCDYNCTRL_DATA_DIR uvcdynctrl DATA_DIR)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
add_definitions (-DHAVE_CONFIG_H)

#create man pages
execute_process (
	COMMAND			sh -c "rm -f ${CMAKE_CURRENT_BINARY_DIR}/*.gz; cp ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1_ ${CMAKE_CURRENT_BINARY_DIR}/uvcdynctrl.1; cp ${CMAKE_CURRENT_SOURCE_DIR}/uvcdynctrl.1_ ${CMAKE_CURRENT_BINARY_DIR}/uvcdynctrl-${UVCDYNCTRL_VERSION}.1; gzip --best ${CMAKE_CURRENT_BINARY_DIR}/uvcdynctrl-${UVCDYNCTRL_VERSION}.1; gzip --best ${CMAKE_CURRENT_BINARY_DIR}/uvcdynctrl.1;"
	RESULT_VARIABLE		MAN_BUILD_RESULT
	
)

if (MAN_BUILD_RESULT)
	message(ERROR " Unable to build man pages")
else (MAN_BUILD_RESULT)
	message("** created man pages")
endif (MAN_BUILD_RESULT)

#
# COMPILATION AND LINKING
#

include_directories (../common/include)
include_directories (${CMAKE_CURRENT_BINARY_DIR})
link_directories (${LIBWEBCAM_BINARY_DIR}/webcam)

target_link_libraries (uvcdynctrl webcam)

# Compiler flags
set_target_properties (uvcdynctrl PROPERTIES
	COMPILE_FLAGS "--std=gnu99 -Wall"
)

#
# INSTALLATION
#

# uvcdynctrl binary
message("** Installation directory for uvcdynctrl: ${CMAKE_INSTALL_PREFIX}/bin")
install (
	TARGETS					uvcdynctrl
	RUNTIME DESTINATION		bin
	COMPONENT				UVCDYNCTRL
)

# udev rules, script, and data
# Default permissions for DIRECTORY files: rw-r--r--
# Default permissions for PROGRAMS files:  rwxr-xr-x
# Note that having absolute paths here requires CPACK_SET_DESTDIR to be set to "ON".
install (
	FILES	udev/rules/80-uvcdynctrl.rules
	DESTINATION /lib/udev/rules.d
)
install (
	PROGRAMS	udev/scripts/uvcdynctrl
	DESTINATION	/lib/udev
)
install (
	DIRECTORY	data
	DESTINATION ${UVCDYNCTRL_DATA_DIR}
	PATTERN ".git" EXCLUDE
)
install (
	FILES	${CMAKE_CURRENT_BINARY_DIR}/uvcdynctrl.1.gz ${CMAKE_CURRENT_BINARY_DIR}/uvcdynctrl-${UVCDYNCTRL_VERSION}.1.gz 
	DESTINATION share/man/man1
)

=== debian/changelog ===
libwebcam (0.2.2-1) unstable; urgency=low

  * Update to 0.2.2 - now hosted at sourceforge
  * Remove Debian patches - merged upstream
  * Update copyright
  * Define uvcdynctrl package section to utils (Closes: #663083)
  * Update Debian Standards Version to 3.9.3

 -- Paulo Assis <pj.assis@gmail.com>  Wed, 09 May 2012 12:12:23 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,24 +1,32 @@
 #!/usr/bin/make -f
-
-include /usr/share/quilt/quilt.make
 
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
+# Uncomment this to turn on all hardening flags
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# extra flags
+#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs
+
+CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
+CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
+LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
+
 # shared library version
-version= 0.2.1
+version= 0.2.2
 deb_version=$(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
 
 major=0
 
 builddir/Makefile:
-	dh_quilt_patch 
 	dh_testdir
 	# Add here commands to configure the package.
 	mkdir -p builddir
-	cd builddir && cmake .. -DCMAKE_INCLUDE_PATH=../common/include \
-		-DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_C_FLAGS="$(CFLAGS)" \
-		-DCMAKE_LD_FLAGS="-Wl,-z,defs" -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
+	cd builddir && cmake .. -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_C_FLAGS="$(CFLAGS)" \
+		-DCMAKE_LD_FLAGS="$(LDFLAGS)" -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
 		-DCMAKE_SKIP_RPATH=ON -DCMAKE_VERBOSE_MAKEFILE=ON
 
 #build-doxy: build-doxy-stamp
@@ -27,7 +35,11 @@
 #	doxygen
 #	touch $@
 
-build:  build-stamp
+build: build-arch build-indep
+
+build-arch:  build-stamp
+
+build-indep: build-stamp
 	
 build-stamp:  builddir/Makefile 
 	dh_testdir
@@ -36,13 +48,10 @@
 	touch $@
 
 clean: 
-	dh_quilt_unpatch
 	dh_testdir
 	dh_testroot
 	rm -f build-stamp 
 	# Add here commands to clean up after the build process.
-	rm -rf libwebcam/pkgconfig/libwebcam.pc
-	rm -rf uvcdynctrl/*.gz
 	rm -rf builddir
 	dh_clean

## libwebcam 0.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,14 @@
 # Require CMake 2.6 because of the Debian packaging.
 cmake_minimum_required (VERSION 2.6)
 
+# uninstall target
+configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+    IMMEDIATE @ONLY)
+
+add_custom_target(uninstall
+    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 
 
 #

=== libwebcam/CMakeLists.txt ===
--- 
+++ 
@@ -16,8 +16,8 @@
 add_library (webcam SHARED libwebcam.c dynctrl.c)
 add_library (webcam_static STATIC libwebcam.c dynctrl.c)
 
-set_target_properties (webcam PROPERTIES VERSION 0.2.2 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
-set_target_properties (webcam_static PROPERTIES VERSION 0.2.2 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
+set_target_properties (webcam PROPERTIES VERSION 0.2.4 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
+set_target_properties (webcam_static PROPERTIES VERSION 0.2.4 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
 
 
 
@@ -65,7 +65,7 @@
 if (PC_EXECUTE_RESULT)
 	message(ERROR " Unable to parse ${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/libwebcam.pc_base")
 else (PC_EXECUTE_RESULT)
-	message("** created libwecam.pc")
+	message("** created libwebcam.pc")
 endif (PC_EXECUTE_RESULT)
 
 
@@ -75,7 +75,11 @@
 #
 
 if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
-	SET(CMAKE_INSTALL_LIBDIR "lib")
+	if (DEFINED LIB_INSTALL_DIR)
+		SET(CMAKE_INSTALL_LIBDIR ${LIB_INSTALL_DIR})
+	else (DEFINED LIB_INSTALL_DIR)
+		SET(CMAKE_INSTALL_LIBDIR "lib")
+	endif (DEFINED LIB_INSTALL_DIR)
 endif (NOT DEFINED CMAKE_INSTALL_LIBDIR)
 
 if (${CMAKE_INSTALL_LIBDIR} MATCHES "^/")

=== uvcdynctrl/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 add_executable (uvcdynctrl main.c controls.c cmdline.c)
 
-set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.2)
+set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.4)
 
 if (NOT DYNCTRL_DATA_DIR)
 	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/uvcdynctrl")

=== debian/changelog ===
libwebcam (0.2.4-1.1ubuntu2) artful; urgency=medium

  * Feed -DCMAKE_INSTALL_LIBDIR to the build as dh(1) would do, to
    work around apparent behaviour change in cmake (LP: #1707074)

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 27 Jul 2017 16:35:48 -0600

libwebcam (0.2.4-1.1ubuntu1) vivid; urgency=medium

  * Fix installation into multiarch directories.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 04 Mar 2015 16:29:08 +0100

libwebcam (0.2.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Install dynctrl-logitech.h (Closes: #770982)

 -- Matt Kraai <kraai@debian.org>  Sat, 29 Nov 2014 06:52:05 -0800

libwebcam (0.2.4-1) unstable; urgency=low

  * Bump to version 0.2.4 (Closes: #713548)

 -- Paulo Assis <pj.assis@gmail.com>  Thu, 31 Oct 2013 21:28:00 +0100
 

libwebcam (0.2.3-1) unstable; urgency=low

  * Bump version to 0.2.3

 -- Paulo Assis <pj.assis@gmail.com>  Wed, 07 Aug 2013 11:16:00 +0100

=== debian/control ===
Source: libwebcam
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paulo Assis <pj.assis@gmail.com>
Build-Depends: debhelper (>= 7), cmake, libxml2-dev, pkg-config, gengetopt
Standards-Version: 3.9.3
Homepage: http://www.quickcamteam.net/software/libwebcam

Package: libwebcam0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Webcam Library 
 The Webcam Library libwebcam is designed to simplify 
 the development of webcam applications, primarily on Linux but 
 with an option to be ported to other platforms, in particular 
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

Package: libwebcam0-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libwebcam0 (= ${binary:Version})
Description: Webcam Library - Development files
 This package provides the files needed to build apps that use libwecam.
 .
 The Webcam Library libwebcam is designed to simplify 
 the development of webcam applications, primarily on Linux but 
 with an option to be ported to other platforms, in particular 
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.
 
Package: libwebcam0-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libwebcam0 (= ${binary:Version})
Description: Debug Symbols for the Webcam Library
 This package contains debug data of the libwebcam related shared libraries.
 .
 Most people will not need this package. Please install it to produce useful
 stacktraces to help debugging the webcam library.
 .
 The Webcam Library libwebcam is designed to simplify 
 the development of webcam applications, primarily on Linux but 
 with an option to be ported to other platforms, in particular 
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

Package: uvcdynctrl-data
Section: utils
Architecture: all
Depends: ${misc:Depends}
Description: Command line tool to control v4l2 devices - data files
 This package provides data files needed by uvcdynctrl to add
 vendor specific controls to uvc devices
 .
 uvcdynctrl is part of the Webcam Library.
 .
 The Webcam Library libwebcam is designed to simplify 
 the development of webcam applications, primarily on Linux but 
 with an option to be ported to other platforms, in particular 
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

Package: uvcdynctrl
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libwebcam0 (= ${binary:Version}), uvcdynctrl-data
Description: Command line tool to control v4l2 devices
 This package provides the tools needed to add vendor specific
 controls to uvc devices.
 .
 uvcdynctrl is part of the Webcam Library.
 .
 The Webcam Library libwebcam is designed to simplify 
 the development of webcam applications, primarily on Linux but 
 with an option to be ported to other platforms, in particular 
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

Package: uvcdynctrl-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, uvcdynctrl (= ${binary:Version})
Description: Debug Symbols for uvcdynctrl
 This package contains debug data for uvcdynctrl
 .
 Most people will not need this package. Please install it to produce useful
 stacktraces to help debugging the webcam library.
 .
 uvcdynctrl is part of the Webcam Library.
 .
 The Webcam Library libwebcam is designed to simplify 
 the development of webcam applications, primarily on Linux but 
 with an option to be ported to other platforms, in particular 
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
 
 # shared library version
-version= 0.2.2
+version= 0.2.4
 deb_version=$(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
 
 major=0
@@ -27,6 +27,7 @@
 	mkdir -p builddir
 	cd builddir && cmake .. -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_C_FLAGS="$(CFLAGS)" \
 		-DCMAKE_LD_FLAGS="$(LDFLAGS)" -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
+		-DCMAKE_INSTALL_LIBDIR="lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)" \
 		-DCMAKE_SKIP_RPATH=ON -DCMAKE_VERBOSE_MAKEFILE=ON
 
 #build-doxy: build-doxy-stamp

## libwebcam 0.2.5

=== libwebcam/CMakeLists.txt ===
--- 
+++ 
@@ -16,8 +16,8 @@
 add_library (webcam SHARED libwebcam.c dynctrl.c)
 add_library (webcam_static STATIC libwebcam.c dynctrl.c)
 
-set_target_properties (webcam PROPERTIES VERSION 0.2.4 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
-set_target_properties (webcam_static PROPERTIES VERSION 0.2.4 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
+set_target_properties (webcam PROPERTIES VERSION 0.2.6 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
+set_target_properties (webcam_static PROPERTIES VERSION 0.2.6 SOVERSION 0 CLEAN_DIRECT_OUTPUT 1 OUTPUT_NAME "webcam")
 
 
 
@@ -103,7 +103,7 @@
 )
 
 install (
-	FILES	../common/include/webcam.h
+	FILES	../common/include/webcam.h ../common/include/dynctrl-logitech.h
 	DESTINATION 	${CMAKE_INSTALL_PREFIX}/include
 )

=== uvcdynctrl/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 add_executable (uvcdynctrl main.c controls.c cmdline.c)
 
-set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.4)
+set_target_properties (uvcdynctrl PROPERTIES VERSION 0.2.6)
 
 if (NOT DYNCTRL_DATA_DIR)
 	set_target_properties (uvcdynctrl PROPERTIES DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/uvcdynctrl")

=== debian/changelog ===
libwebcam (0.2.5-5) unstable; urgency=medium

  * 'd/control':
    - Adopt package. (Closes: #1032678)
    - Update 'Standards-Version to 4.7.0, no changes required.
    - Update 'Build-Depends', pkg-config to pkgconf.
  * 'd/copyright':
    - Add myself, Phil Wyett to 'Files: debian/*' section.
  * 'd/rules':
    - Disable 'DH_VERBOSE'.
  * Add 'd/watch' file to package.

 -- Phil Wyett <philip.wyett@kathenas.org>  Sat, 28 Sep 2024 10:14:03 +0100

libwebcam (0.2.5-4) unstable; urgency=medium

  * QA upload.
  * Use udev.pc to place udev files

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 09 Dec 2023 00:20:21 +0100

libwebcam (0.2.5-3) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + libwebcam0: Add Multi-Arch: same.
    + uvcdynctrl-data: Add Multi-Arch: foreign.

  [ Boyuan Yang ]
  * Orphan the package. (See #1032678)
  * Do not mention nonexistent Texinfo in man page. (LP: #1933287)

 -- Boyuan Yang <byang@debian.org>  Fri, 16 Jun 2023 23:28:48 -0400

libwebcam (0.2.5-2) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.6.1.
  * debian/control: Restrict architecture to linux-any.
  * debian/patches: Add patch to fix package reproducibility.
    (Closes: #787999)
  * debian/changelog: Remove trailing spaces.

 -- Boyuan Yang <byang@debian.org>  Sun, 21 Aug 2022 19:44:40 -0400

libwebcam (0.2.5-1) unstable; urgency=medium

  * New upstream release. (Closes: #917935) (Closes: #733094)
    + Fixes unconditinoal filling up /var. (LP: #811604) (LP: #1902429)
  * debian/control:
    + Take over package maintenance. (Closes: #1017102)
    + Use Priority: optional.
    + Add Vcs-* fields.
    + Bump debhelper compat to v13.
    + Set homepage to SourceForge.
  * debian/rules: Migrate to dh13 syntax. (Closes: #878475)
  * Migrate to automatic -dbgsym packages.
  * debian/: Apply wrap-and-sort -abst.
  * debian/README.source: Dropped, useless.
  * debian/patches: Drop all old patches, merged upstream.
  * debian/docs: Updated, do not include CMakeLists.txt
  * debian/*.dirs: Dropped, useless.
  * debian/docs: Moved to libwebcam0-dev.docs.

 -- Boyuan Yang <byang@debian.org>  Sun, 21 Aug 2022 16:17:41 -0400

=== debian/control ===
Source: libwebcam
Section: libs
Priority: optional
Maintainer: Phil Wyett <philip.wyett@kathenas.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 gengetopt,
 libxml2-dev,
 pkgconf,
 systemd-dev,
Standards-Version: 4.7.0
Homepage: https://sourceforge.net/projects/libwebcam/
Vcs-Git: https://salsa.debian.org/debian/libwebcam.git
Vcs-Browser: https://salsa.debian.org/debian/libwebcam

Package: libwebcam0
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: Webcam Library
 The Webcam Library libwebcam is designed to simplify
 the development of webcam applications, primarily on Linux but
 with an option to be ported to other platforms, in particular
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

Package: libwebcam0-dev
Section: libdevel
Architecture: linux-any
Depends:
 libwebcam0 (= ${binary:Version}),
 ${misc:Depends},
Description: Webcam Library - Development files
 This package provides the files needed to build apps that use libwecam.
 .
 The Webcam Library libwebcam is designed to simplify
 the development of webcam applications, primarily on Linux but
 with an option to be ported to other platforms, in particular
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

Package: uvcdynctrl
Section: utils
Architecture: linux-any
Depends:
 libwebcam0 (= ${binary:Version}),
 uvcdynctrl-data,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Command line tool to control v4l2 devices
 This package provides the tools needed to add vendor specific
 controls to uvc devices.
 .
 uvcdynctrl is part of the Webcam Library.
 .
 The Webcam Library libwebcam is designed to simplify
 the development of webcam applications, primarily on Linux but
 with an option to be ported to other platforms, in particular
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

Package: uvcdynctrl-data
Section: utils
Architecture: all
Depends:
 ${misc:Depends},
Multi-Arch: foreign
Description: Command line tool to control v4l2 devices - data files
 This package provides data files needed by uvcdynctrl to add
 vendor specific controls to uvc devices
 .
 uvcdynctrl is part of the Webcam Library.
 .
 The Webcam Library libwebcam is designed to simplify
 the development of webcam applications, primarily on Linux but
 with an option to be ported to other platforms, in particular
 Solaris. It realizes part of what the unwritten Video4Linux user
 space library was always supposed to be: an easy to use library
 that shields its users from many of the difficulties and problems
 of using the V4L2 API directly.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Uncomment this to turn on all hardening flags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export deb_udevdir = $(shell pkg-config --variable=udevdir udev | sed s,^/,,)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DUDEVDIR=/$(deb_udevdir)

=== debian/watch ===
version=4
# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
http://sf.net/libwebcam/libwebcam-src-(\d\S+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
